//+------------------------------------------------------------------+

#property link      "www.forex-tsd.com"  
#property copyright "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    5
#property indicator_minimum    0
#property indicator_maximum    100
#property indicator_color1     clrDarkSlateGray
#property indicator_color2     clrDarkSlateGray
#property indicator_color3     clrDarkSlateGray
#property indicator_color4     clrAqua
#property indicator_color5     clrMagenta  


//
//
//
//
//

extern int                RsiPeriod                = 14;
extern ENUM_APPLIED_PRICE Price                    = 0;
extern int                DemaPeriod               = 10;
extern int                VolatilityBandPeriod     = 34;
extern ENUM_MA_METHOD     VolatilityBandMAMode     = MODE_SMA;
extern double             VolatilityBandMultiplier = 1.6185;
extern bool               ShowMidBand              = false;

//
//
//
//
//

double bandUp[];
double bandMi[];
double bandDn[];
double rsi[];
double rsiMa[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//
//

int init()
{
   SetIndexBuffer(0,bandUp);
   SetIndexBuffer(1,bandMi);
   SetIndexBuffer(2,bandDn);
   SetIndexBuffer(3,rsi); 
   SetIndexBuffer(4,rsiMa); 
   if (ShowMidBand)
   {
      SetIndexStyle(1,DRAW_LINE); 
   }
   else
   {
      SetIndexStyle(1,DRAW_NONE);
   }       
   IndicatorShortName(" Rsi + Dema ("+RsiPeriod+","+DemaPeriod+")");
return(0);
}

//
//
//
//
//

int deinit() 
{ 
   
return(0); 
}

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
  
   for(i=limit; i >= 0; i--) rsi[i] = iRsi(iMA(NULL,0,1,0,MODE_SMA,Price,i),RsiPeriod,i);
   for(i=limit; i >= 0; i--)
   {
      rsiMa[i] = iDema(rsi[i],DemaPeriod,i);
      double deviation = iStdDevOnArray(rsi,0,VolatilityBandPeriod,0,VolatilityBandMAMode,i);
      double average   = iMAOnArray(rsi,0,VolatilityBandPeriod,0,VolatilityBandMAMode,i);
             bandUp[i] = average+VolatilityBandMultiplier*deviation;
             bandDn[i] = average-VolatilityBandMultiplier*deviation;
             bandMi[i] = average;   
   }
return(0);           
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double workRsi[][3];
#define _price  0
#define _change 1
#define _changa 2

//
//
//
//

double iRsi(double price, double period, int shift, int forz=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int    z     = forz*3; 
      int    i     = Bars-shift-1;
      double alpha = 1.0/period; 

   //
   //
   //
   //
   //
   
   workRsi[i][_price+z] = price;
   if (i<period)
      {
         int k; double sum = 0; for (k=0; k<period && (i-k-1)>=0; k++) sum += MathAbs(workRsi[i-k][_price+z]-workRsi[i-k-1][_price+z]);
            workRsi[i][_change+z] = (workRsi[i][_price+z]-workRsi[0][_price+z])/MathMax(k,1);
            workRsi[i][_changa+z] =                                         sum/MathMax(k,1);
      }
   else
      {
         double change = workRsi[i][_price+z]-workRsi[i-1][_price+z];
                         workRsi[i][_change+z] = workRsi[i-1][_change+z] + alpha*(        change  - workRsi[i-1][_change+z]);
                         workRsi[i][_changa+z] = workRsi[i-1][_changa+z] + alpha*(MathAbs(change) - workRsi[i-1][_changa+z]);
      }
   if (workRsi[i][_changa+z] != 0)
         return(50.0*(workRsi[i][_change+z]/workRsi[i][_changa+z]+1));
   else  return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workDema[][3];
#define _ema1 0
#define _ema2 1

double iDema(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workDema,0)!= Bars) ArrayResize(workDema,Bars); instanceNo*=2; r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workDema[r][_ema1+instanceNo] = workDema[r-1][_ema1+instanceNo]+alpha*(price                        -workDema[r-1][_ema1+instanceNo]);
          workDema[r][_ema2+instanceNo] = workDema[r-1][_ema2+instanceNo]+alpha*(workDema[r][_ema1+instanceNo]-workDema[r-1][_ema2+instanceNo]);
   return(workDema[r][_ema1+instanceNo]*2.0-workDema[r][_ema2+instanceNo]);
}


